#!/usr/local/bin/bash

# endpoints="localhost" filename="/home/llh/pingstats.json"

if test -f "$filename"; then
  echo "file $filename already exists."
else
  touch "$filename"
  echo "{}" > "$filename"
fi

if [[ -n "$nfsFilename" ]]; then
  if test -f "$nfsFilename"; then
    echo "NFS file $nfsFilename already exists."
  else
    touch "$nfsFilename"
    echo "{}" > "$nfsFilename"
  fi
fi

echo ping "${endpoints} every ${downtime:=3} sec, saving to ${filename}"
# for endpoints in "${endpoints[@]}"; do
# done

# --------------------------------------
while true; do

  # for endpoints in "${endpoints[@]}"; do

  # echo pinging "${endpoints} now ..."
  newData=$(ping -c 3 ${endpoints:=localhost} | tail -n 1)

  # if nothing comes back, we dont write anything
  if [[ -n "$newData" ]]; then
    false
    echo "$newData"
  else
    echo "${endpoints} might be unreachable"
    continue
  fi

  OLDIFS=$IFS
  IFS=" "
  read bit1 bit2 bit3 bit4 bit5 <<< "$newData"
  IFS="/"
  read num1 num2 num3 num4 <<< "$bit4"
  IFS=$OLDIFS

  if test -f "$filename"; then
    false
  else
    touch "$filename"
    echo "{}" > "$filename"
  fi

  echo "debugging:"
  echo $num1
  echo $num2
  echo $num3
  echo $num4

  # keep a diary
  if [[ -n "$num4" ]]; then
    jq --arg timedate $(date +"%H:%M_%F") --arg target $endpoints --argjson rttMin $num1 --argjson rttAvg $num2 --argjson rttMax $num3 --argjson stdDev $num4 '.[$target][$timedate] += [{"min":$rttMin,"avg":$rttAvg,"max":$rttMax,"std":$stdDev}]' "$filename" > "$filename.tmp" && mv "$filename.tmp" "$filename"
  else
    jq --arg timedate $(date +"%H:%M_%F") --arg target $endpoints --argjson rttMin $num1 --argjson rttAvg $num2 --argjson rttMax $num3 '.[$target][$timedate] += [{"min":$rttMin,"avg":$rttAvg,"max":$rttMax}]' "$filename" > "$filename.tmp" && mv "$filename.tmp" "$filename"
  fi

  # write home about it (if connected)
  if [[ -n "$nfsFilename" ]]; then
    if [[ -n "$num4" ]]; then
      jq --arg timedate $(date +"%H:%M_%F") --arg hostname $HOSTNAME --arg target $endpoints --argjson rttMin $num1 --argjson rttAvg $num2 --argjson rttMax $num3 --argjson stdDev $num4 '.[$hostname][$target][$timedate] += [{"min":$rttMin,"avg":$rttAvg,"max":$rttMax,"std":$stdDev}]' "$nfsFilename" > "$nfsFilename.tmp" && mv "$nfsFilename.tmp" "$nfsFilename"
    else
      jq --arg timedate $(date +"%H:%M_%F") --arg hostname $HOSTNAME --arg target $endpoints --argjson rttMin $num1 --argjson rttAvg $num2 --argjson rttMax $num3 '.[$hostname][$target][$timedate] += [{"min":$rttMin,"avg":$rttAvg,"max":$rttMax}]' "$nfsFilename" > "$nfsFilename.tmp" && mv "$nfsFilename.tmp" "$nfsFilename"
    fi
  fi

  # done

  sleep ${downtime:=3}
done

if test -f "$filename.tmp"; then
  rm "$filename.tmp"
fi

if test -f "$nfsFilename.tmp"; then
  rm "$nfsFilename.tmp"
fi
